#include <stdio.h>
#include <stdlib.h>
#include <libvirt/libvirt.h>
int main(int argc, char *argv[]){
	virConnectPtr conn;
	int i;
	int numDomains;
	int *activeDomains;
	
	conn = virConnectOpen("xen:///");

	if (conn == NULL) {
		fprintf(stderr, "Failed to open connection to xen:///\n");
		return -1;
	}

	//     ӽ 
	numDomains = virConnectNumOfDomains(conn);
	activeDomains = malloc(sizeof(int) * numDomains);

	//    ӽ  activeDomains ´.
	numDomains = virConnectListDomains(conn, activeDomains, numDomains);
	printf("Active domain IDs:\n");
	for (i = 0 ; i < numDomains ; i++) {
		printf(" %d\n", activeDomains[i]);
	}
	
	free(activeDomains);
	virConnectClose(conn);
	return 0;
}